Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zrem.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zrem.F90	(revision 7909)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zrem.F90	(revision 7910)
@@ -67,6 +67,6 @@
       REAL(wp) ::   zosil, ztem, zdenitnh4, zolimic, zolimin, zolimip, zdenitrn, zdenitrp
       CHARACTER (len=25) :: charout
-      REAL(wp), POINTER, DIMENSION(:,:  ) :: ztempbac
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: zdepbac, zolimi, zdepprod, zfacsi, zw3d, zfacsib
+      REAL(wp), DIMENSION(jpi,jpj) :: ztempbac
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zdepbac, zolimi, zdepprod, zfacsi, zw3d, zfacsib
       !!---------------------------------------------------------------------
       !
@@ -74,6 +74,4 @@
       !
       ! Allocate temporary workspace
-      CALL wrk_alloc( jpi, jpj,      ztempbac                  )
-      CALL wrk_alloc( jpi, jpj, jpk, zdepbac, zdepprod, zolimi, zfacsi, zfacsib )
 
       ! Initialisation of temprary arrys
@@ -267,5 +265,4 @@
 
       IF( knt == nrdttrc ) THEN
-          CALL wrk_alloc( jpi, jpj, jpk, zw3d )
           zfact = 1.e+3 * rfact2r  !  conversion from mol/l/kt to  mol/m3/s
           !
@@ -279,9 +276,6 @@
           ENDIF
           !
-          CALL wrk_dealloc( jpi, jpj, jpk, zw3d )
        ENDIF
       !
-      CALL wrk_dealloc( jpi, jpj,      ztempbac                  )
-      CALL wrk_dealloc( jpi, jpj, jpk, zdepbac, zdepprod, zolimi, zfacsi, zfacsib )
       !
       IF( nn_timing == 1 )  CALL timing_stop('p4z_rem')
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zsed.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zsed.F90	(revision 7909)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zsed.F90	(revision 7910)
@@ -62,10 +62,10 @@
       !
       CHARACTER (len=25) :: charout
-      REAL(wp), POINTER, DIMENSION(:,:  ) :: zsidep, zwork1, zwork2, zwork3
-      REAL(wp), POINTER, DIMENSION(:,:  ) :: zdenit2d, zironice, zbureff
-      REAL(wp), POINTER, DIMENSION(:,:  ) :: zwsbio3, zwsbio4, zwscal
-      REAL(wp), POINTER, DIMENSION(:,:  ) :: zsedcal, zsedsi, zsedc
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: ztrpo4, ztrdop, zirondep, zsoufer, zpdep, zlight
-      REAL(wp), POINTER, DIMENSION(:,:  ) :: zwsfep
+      REAL(wp), DIMENSION(jpi,jpj) :: zsidep, zwork1, zwork2, zwork3
+      REAL(wp), DIMENSION(jpi,jpj) :: zdenit2d, zironice, zbureff
+      REAL(wp), DIMENSION(jpi,jpj) :: zwsbio3, zwsbio4, zwscal
+      REAL(wp), DIMENSION(jpi,jpj) :: zsedcal, zsedsi, zsedc
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: ztrpo4, ztrdop, zirondep, zsoufer, zpdep, zlight
+      REAL(wp), DIMENSION(jpi,jpj) :: zwsfep
 
       !!---------------------------------------------------------------------
@@ -76,10 +76,4 @@
       !
       ! Allocate temporary workspace
-                      CALL wrk_alloc( jpi, jpj, zdenit2d, zwork1, zwork2, zwork3, zbureff )
-                      CALL wrk_alloc( jpi, jpj, zwsbio3, zwsbio4, zwscal )
-                      CALL wrk_alloc( jpi, jpj, zsedcal,  zsedsi, zsedc )
-                      CALL wrk_alloc( jpi, jpj, jpk, zlight, zsoufer )
-      IF( ln_p5z )    CALL wrk_alloc( jpi, jpj, jpk, ztrpo4, ztrdop )
-      IF( ln_ligand ) CALL wrk_alloc( jpi, jpj, zwsfep )
 
 
@@ -98,5 +92,4 @@
       IF( ln_ironice ) THEN  
          !                                              
-         CALL wrk_alloc( jpi, jpj, zironice )
          !                                              
          DO jj = 1, jpj
@@ -115,5 +108,4 @@
             &   CALL iom_put( "Ironice", zironice(:,:) * 1.e+3 * rfact2r * e3t_n(:,:,1) * tmask(:,:,1) ) ! iron flux from ice
          !
-         CALL wrk_dealloc( jpi, jpj, zironice )
          !                                              
       ENDIF
@@ -123,6 +115,4 @@
       IF( ln_dust ) THEN
          !                                              
-         CALL wrk_alloc( jpi, jpj,      zsidep )
-         CALL wrk_alloc( jpi, jpj, jpk, zpdep, zirondep      )
          !                                              ! Iron and Si deposition at the surface
          IF( ln_solub ) THEN
@@ -153,6 +143,4 @@
             ENDIF
          ENDIF
-         CALL wrk_dealloc( jpi, jpj,      zsidep )
-         CALL wrk_dealloc( jpi, jpj, jpk, zpdep, zirondep      )
          !                                              
       ENDIF
@@ -516,10 +504,4 @@
       ENDIF
       !
-                      CALL wrk_dealloc( jpi, jpj, zdenit2d, zwork1, zwork2, zwork3, zbureff )
-                      CALL wrk_dealloc( jpi, jpj, zwsbio3, zwsbio4, zwscal )
-                      CALL wrk_dealloc( jpi, jpj, zsedcal,  zsedsi, zsedc )
-                      CALL wrk_dealloc( jpi, jpj, jpk, zlight, zsoufer )
-      IF( ln_p5z )    CALL wrk_dealloc( jpi, jpj, jpk, ztrpo4, ztrdop )
-      IF( ln_ligand ) CALL wrk_dealloc( jpi, jpj, zwsfep )
       !
       IF( nn_timing == 1 )  CALL timing_stop('p4z_sed')
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zsink.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zsink.F90	(revision 7909)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zsink.F90	(revision 7910)
@@ -65,6 +65,6 @@
       REAL(wp) ::   zfact, zwsmax, zmax
       CHARACTER (len=25) :: charout
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: zw3d
-      REAL(wp), POINTER, DIMENSION(:,:  ) :: zw2d
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zw3d
+      REAL(wp), DIMENSION(jpi,jpj) :: zw2d
       !!---------------------------------------------------------------------
       !
@@ -212,6 +212,4 @@
      IF( lk_iomput ) THEN
        IF( knt == nrdttrc ) THEN
-          CALL wrk_alloc( jpi, jpj,      zw2d )
-          CALL wrk_alloc( jpi, jpj, jpk, zw3d )
           zfact = 1.e+3 * rfact2r  !  conversion from mol/l/kt to  mol/m3/s
           !
@@ -250,6 +248,4 @@
           IF( iom_use( "tcexp" ) )  CALL iom_put( "tcexp" , t_oce_co2_exp * zfact )   ! molC/s
           ! 
-          CALL wrk_dealloc( jpi, jpj,      zw2d )
-          CALL wrk_dealloc( jpi, jpj, jpk, zw3d )
         ENDIF
       ENDIF
@@ -302,5 +298,5 @@
       INTEGER  ::   ji, jj, jk, jn
       REAL(wp) ::   zigma,zew,zign, zflx, zstep
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: ztraz, zakz, zwsink2, ztrb 
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: ztraz, zakz, zwsink2, ztrb 
       !!---------------------------------------------------------------------
       !
@@ -308,5 +304,4 @@
       !
       ! Allocate temporary workspace
-      CALL wrk_alloc( jpi, jpj, jpk, ztraz, zakz, zwsink2, ztrb )
 
       zstep = rfact2 / REAL( kiter, wp ) / 2.
@@ -389,5 +384,4 @@
       psinkflx(:,:,:)   = 2. * psinkflx(:,:,:)
       !
-      CALL wrk_dealloc( jpi, jpj, jpk, ztraz, zakz, zwsink2, ztrb )
       !
       IF( nn_timing == 1 )  CALL timing_stop('p4z_sink2')
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zsms.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zsms.F90	(revision 7909)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zsms.F90	(revision 7910)
@@ -424,5 +424,5 @@
       CHARACTER(LEN=100)   ::   cltxt
       INTEGER :: jk
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: zwork
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zwork
       !!----------------------------------------------------------------------
 
@@ -444,5 +444,4 @@
       ENDIF
 
-      CALL wrk_alloc( jpi, jpj, jpk, zwork )
       !
       IF( iom_use( "pno3tot" ) .OR. ( ln_check_mass .AND. kt == nitend )  ) THEN
@@ -510,5 +509,4 @@
       ENDIF
       !
-      CALL wrk_dealloc( jpi, jpj, jpk, zwork )
       !
       ! Global budget of N SMS : denitrification in the water column and in the sediment
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p5zmeso.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p5zmeso.F90	(revision 7909)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p5zmeso.F90	(revision 7910)
@@ -85,5 +85,5 @@
       CHARACTER (len=25) :: charout
       REAL(wp) :: zrfact2, zmetexcess
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: zgrazing, zw3d
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zgrazing, zw3d
 
       !!---------------------------------------------------------------------
@@ -91,5 +91,4 @@
       IF( nn_timing == 1 )  CALL timing_start('p5z_meso')
       !
-      CALL wrk_alloc( jpi, jpj, jpk, zgrazing )
       zgrazing(:,:,:) = 0._wp
 
@@ -342,5 +341,4 @@
       !
       IF( lk_iomput .AND. knt == nrdttrc ) THEN
-         CALL wrk_alloc( jpi, jpj, jpk, zw3d )
          IF( iom_use( "GRAZ2" ) ) THEN
             zw3d(:,:,:) = zgrazing(:,:,:) * 1.e+3 * rfact2r * tmask(:,:,:)  !   Total grazing of phyto by zooplankton
@@ -351,5 +349,4 @@
             CALL iom_put( "PCAL", zw3d )
          ENDIF
-         CALL wrk_dealloc( jpi, jpj, jpk, zw3d )
       ENDIF
       !
@@ -360,5 +357,4 @@
       ENDIF
       !
-      CALL wrk_dealloc( jpi, jpj, jpk, zgrazing )
       !
       IF( nn_timing == 1 )  CALL timing_stop('p5z_meso')
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p5zmicro.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p5zmicro.F90	(revision 7909)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p5zmicro.F90	(revision 7910)
@@ -82,5 +82,5 @@
       REAL(wp) :: zgrazdc, zgrazdn, zgrazdp, zgrazdf, zgraznf, zgrazz
       REAL(wp) :: zgrazpc, zgrazpn, zgrazpp, zgrazpf, zbeta, zrfact2, zmetexcess
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: zgrazing, zw3d
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zgrazing, zw3d
       CHARACTER (len=25) :: charout
       !!---------------------------------------------------------------------
@@ -88,5 +88,4 @@
       IF( nn_timing == 1 )  CALL timing_start('p5z_micro')
       !
-      CALL wrk_alloc( jpi, jpj, jpk, zgrazing )
       !
       zmetexcess = 0.0
@@ -290,10 +289,8 @@
       !
       IF( lk_iomput .AND. knt == nrdttrc ) THEN
-         CALL wrk_alloc( jpi, jpj, jpk, zw3d )
          IF( iom_use( "GRAZ1" ) ) THEN
             zw3d(:,:,:) = zgrazing(:,:,:) * 1.e+3 * rfact2r * tmask(:,:,:)  !  Total grazing of phyto by zooplankton
             CALL iom_put( "GRAZ1", zw3d )
          ENDIF
-         CALL wrk_dealloc( jpi, jpj, jpk, zw3d )
       ENDIF
       !
@@ -304,5 +301,4 @@
       ENDIF
       !
-      CALL wrk_dealloc( jpi, jpj, jpk, zgrazing )
       !
       IF( nn_timing == 1 )  CALL timing_stop('p5z_micro')
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p5zprod.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p5zprod.F90	(revision 7909)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p5zprod.F90	(revision 7910)
@@ -81,19 +81,19 @@
       REAL(wp) ::   zfact, zrfact2
       CHARACTER (len=25) :: charout
-      REAL(wp), POINTER, DIMENSION(:,:  ) :: zmixnano, zmixpico, zmixdiat, zstrn
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: zpislopeadn, zpislopeadp, zpislopeadd
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: zprbio, zprpic, zprdia, zysopt
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: zprchln, zprchlp, zprchld
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: zprorcan, zprorcap, zprorcad 
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: zprofed, zprofep, zprofen
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: zpronewn, zpronewp, zpronewd
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: zproregn, zproregp, zproregd
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: zpropo4n, zpropo4p, zpropo4d
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: zprodopn, zprodopp, zprodopd
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: zrespn, zrespp, zrespd, zprnut
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: zcroissn, zcroissp, zcroissd
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: zmxl_fac, zmxl_chl
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: zw3d
-      REAL(wp), POINTER, DIMENSION(:,:  ) :: zw2d
+      REAL(wp), DIMENSION(jpi,jpj) :: zmixnano, zmixpico, zmixdiat, zstrn
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zpislopeadn, zpislopeadp, zpislopeadd
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zprbio, zprpic, zprdia, zysopt
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zprchln, zprchlp, zprchld
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zprorcan, zprorcap, zprorcad 
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zprofed, zprofep, zprofen
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zpronewn, zpronewp, zpronewd
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zproregn, zproregp, zproregd
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zpropo4n, zpropo4p, zpropo4d
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zprodopn, zprodopp, zprodopd
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zrespn, zrespp, zrespd, zprnut
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zcroissn, zcroissp, zcroissd
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zmxl_fac, zmxl_chl
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zw3d
+      REAL(wp), DIMENSION(jpi,jpj) :: zw2d
       !!---------------------------------------------------------------------
       !
@@ -101,13 +101,4 @@
       !
       !  Allocate temporary workspace
-      CALL wrk_alloc( jpi, jpj,      zmixnano, zmixpico, zmixdiat, zstrn )
-      CALL wrk_alloc( jpi, jpj, jpk, zmxl_fac, zmxl_chl )
-      CALL wrk_alloc( jpi, jpj, jpk, zpislopeadn, zpislopeadp, zpislopeadd, zysopt ) 
-      CALL wrk_alloc( jpi, jpj, jpk, zprdia, zprpic, zprbio, zprorcan, zprorcap, zprorcad )
-      CALL wrk_alloc( jpi, jpj, jpk, zprofed, zprofep, zprofen )
-      CALL wrk_alloc( jpi, jpj, jpk, zpronewn, zpronewp, zpronewd, zproregn, zproregp, zproregd )
-      CALL wrk_alloc( jpi, jpj, jpk, zpropo4n, zpropo4p, zpropo4d, zrespn, zrespp, zrespd, zprnut )
-      CALL wrk_alloc( jpi, jpj, jpk, zprchln, zprchlp, zprchld, zprodopn, zprodopp, zprodopd )
-      CALL wrk_alloc( jpi, jpj, jpk, zcroissp, zcroissn, zcroissd )
       !
       zprorcan(:,:,:) = 0._wp ; zprorcap(:,:,:) = 0._wp ; zprorcad(:,:,:) = 0._wp
@@ -474,6 +465,4 @@
     IF( lk_iomput ) THEN
        IF( knt == nrdttrc ) THEN
-          CALL wrk_alloc( jpi, jpj,      zw2d )
-          CALL wrk_alloc( jpi, jpj, jpk, zw3d )
           zfact = 1.e+3 * rfact2r  !  conversion from mol/l/kt to  mol/m3/s
           !
@@ -550,6 +539,4 @@
           IF( iom_use( "tintpp" ) )  CALL iom_put( "tintpp" , tpp * zfact )  !  global total integrated primary production molC/s
           !
-          CALL wrk_dealloc( jpi, jpj,      zw2d )
-          CALL wrk_dealloc( jpi, jpj, jpk, zw3d )
        ENDIF
      ENDIF
@@ -561,13 +548,4 @@
       ENDIF
       !
-      CALL wrk_dealloc( jpi, jpj,      zmixnano, zmixpico, zmixdiat, zstrn )
-      CALL wrk_dealloc( jpi, jpj, jpk, zmxl_fac, zmxl_chl )
-      CALL wrk_dealloc( jpi, jpj, jpk, zpislopeadn, zpislopeadp, zpislopeadd, zysopt )                           
-      CALL wrk_dealloc( jpi, jpj, jpk, zprdia, zprpic, zprbio, zprorcan, zprorcap, zprorcad )
-      CALL wrk_dealloc( jpi, jpj, jpk, zprofed, zprofep, zprofen ) 
-      CALL wrk_dealloc( jpi, jpj, jpk, zpronewn, zpronewp, zpronewd, zproregn, zproregp, zproregd )
-      CALL wrk_dealloc( jpi, jpj, jpk, zpropo4n, zpropo4p, zpropo4d, zrespn, zrespp, zrespd, zprnut )
-      CALL wrk_dealloc( jpi, jpj, jpk, zprchln, zprchlp, zprchld, zprodopn, zprodopp, zprodopd )
-      CALL wrk_dealloc( jpi, jpj, jpk, zcroissp, zcroissn, zcroissd )
       !
       IF( nn_timing == 1 )  CALL timing_stop('p5z_prod')
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/TRP/trcadv.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/TRP/trcadv.F90	(revision 7909)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/TRP/trcadv.F90	(revision 7910)
@@ -78,10 +78,9 @@
       INTEGER ::   jk   ! dummy loop index
       CHARACTER (len=22) ::   charout
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: zun, zvn, zwn  ! effective velocity
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zun, zvn, zwn  ! effective velocity
       !!----------------------------------------------------------------------
       !
       IF( nn_timing == 1 )   CALL timing_start('trc_adv')
       !
-      CALL wrk_alloc( jpi,jpj,jpk,   zun, zvn, zwn )
       !                                               !==  effective transport  ==!
       IF( l_offline ) THEN
@@ -135,5 +134,4 @@
       END IF
       !
-      CALL wrk_dealloc( jpi,jpj,jpk,   zun, zvn, zwn )
       !
       IF( nn_timing == 1 )  CALL timing_stop('trc_adv')
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/TRP/trcbbl.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/TRP/trcbbl.F90	(revision 7909)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/TRP/trcbbl.F90	(revision 7910)
@@ -49,5 +49,5 @@
       INTEGER, INTENT( in ) ::   kt   ! ocean time-step 
       CHARACTER (len=22) :: charout
-      REAL(wp), POINTER, DIMENSION(:,:,:,:) ::   ztrtrd
+      REAL(wp), DIMENSION(jpi,jpj,jpk,jptra) ::   ztrtrd
       !!----------------------------------------------------------------------
       !
@@ -60,5 +60,4 @@
 
       IF( l_trdtrc )  THEN
-         CALL wrk_alloc( jpi, jpj, jpk, jptra, ztrtrd ) ! temporary save of trends
          ztrtrd(:,:,:,:)  = tra(:,:,:,:)
       ENDIF
@@ -91,5 +90,4 @@
            CALL trd_tra( kt, 'TRC', jn, jptra_bbl, ztrtrd(:,:,:,jn) )
         END DO
-        CALL wrk_dealloc( jpi, jpj, jpk, jptra, ztrtrd ) ! temporary save of trends
       ENDIF
       !
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/TRP/trcdmp.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/TRP/trcdmp.F90	(revision 7909)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/TRP/trcdmp.F90	(revision 7910)
@@ -85,15 +85,13 @@
       INTEGER ::   ji, jj, jk, jn, jl   ! dummy loop indices
       CHARACTER (len=22) ::   charout
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::   ztrtrd
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::   ztrcdta   ! 3D  workspace
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   ztrtrd
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   ztrcdta   ! 3D  workspace
       !!----------------------------------------------------------------------
       !
       IF( nn_timing == 1 )  CALL timing_start('trc_dmp')
       !
-      IF( l_trdtrc )   CALL wrk_alloc( jpi, jpj, jpk, ztrtrd )   ! temporary save of trends
       !
       IF( nb_trcdta > 0 ) THEN  ! Initialisation of tracer from a file that may also be used for damping
          !
-         CALL wrk_alloc( jpi, jpj, jpk, ztrcdta )    ! Memory allocation
          !                                                          ! ===========
          DO jn = 1, jptra                                           ! tracer loop
@@ -150,8 +148,6 @@
          END DO                                                     ! tracer loop
          !                                                          ! ===========
-         CALL wrk_dealloc( jpi, jpj, jpk, ztrcdta )
-      ENDIF
-      !
-      IF( l_trdtrc )  CALL wrk_dealloc( jpi, jpj, jpk, ztrtrd )
+      ENDIF
+      !
       !                                          ! print mean trends (used for debugging)
       IF( ln_ctl ) THEN
@@ -243,5 +239,5 @@
       INTEGER :: ji , jj, jk, jn, jl, jc                    ! dummy loop indicesa
       INTEGER :: isrow                                      ! local index
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::  ztrcdta       ! 3D  workspace
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::  ztrcdta       ! 3D  workspace
 
       !!----------------------------------------------------------------------
@@ -355,5 +351,4 @@
          IF(lwp)  WRITE(numout,*)
          !
-         CALL wrk_alloc( jpi, jpj, jpk, ztrcdta )   ! Memory allocation
          !
          DO jn = 1, jptra
@@ -373,5 +368,4 @@
              ENDIF
           ENDDO
-          CALL wrk_dealloc( jpi, jpj, jpk, ztrcdta )
       ENDIF
       !
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/TRP/trcldf.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/TRP/trcldf.F90	(revision 7909)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/TRP/trcldf.F90	(revision 7910)
@@ -68,6 +68,6 @@
       REAL(wp)           :: zdep
       CHARACTER (len=22) :: charout
-      REAL(wp), POINTER, DIMENSION(:,:,:)   ::   zahu, zahv
-      REAL(wp), POINTER, DIMENSION(:,:,:,:) ::   ztrtrd
+      REAL(wp), DIMENSION(jpi,jpj,jpk)   ::   zahu, zahv
+      REAL(wp), DIMENSION(jpi,jpj,jpk,jptra) ::   ztrtrd
       !!----------------------------------------------------------------------
       !
@@ -75,9 +75,7 @@
       !
       IF( l_trdtrc )  THEN
-         CALL wrk_alloc( jpi,jpj,jpk,jptra,   ztrtrd )
          ztrtrd(:,:,:,:)  = tra(:,:,:,:)
       ENDIF
       !                                  !* set the lateral diffusivity coef. for passive tracer      
-      CALL wrk_alloc( jpi,jpj,jpk,   zahu, zahv )
       zahu(:,:,:) = rldf * ahtu(:,:,:) 
       zahv(:,:,:) = rldf * ahtv(:,:,:)
@@ -115,5 +113,4 @@
            CALL trd_tra( kt, 'TRC', jn, jptra_ldf, ztrtrd(:,:,:,jn) )
         END DO
-        CALL wrk_dealloc( jpi, jpj, jpk, jptra, ztrtrd )
       ENDIF
       !                
@@ -124,5 +121,4 @@
       ENDIF
       !
-      CALL wrk_dealloc( jpi,jpj,jpk,   zahu, zahv )
       !
       IF( nn_timing == 1 )   CALL timing_stop('trc_ldf')
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/TRP/trcnxt.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/TRP/trcnxt.F90	(revision 7909)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/TRP/trcnxt.F90	(revision 7910)
@@ -82,5 +82,5 @@
       REAL(wp) ::   zfact            ! temporary scalar
       CHARACTER (len=22) :: charout
-      REAL(wp), POINTER, DIMENSION(:,:,:,:) ::  ztrdt 
+      REAL(wp), DIMENSION(jpi,jpj,jpk,jptra) ::  ztrdt 
       !!----------------------------------------------------------------------
       !
@@ -102,5 +102,4 @@
 
       IF( l_trdtrc )  THEN             ! trends: store now fields before the Asselin filter application
-         CALL wrk_alloc( jpi, jpj, jpk, jptra, ztrdt )
          ztrdt(:,:,:,:)  = trn(:,:,:,:)
       ENDIF
@@ -137,5 +136,4 @@
             END DO
          END DO
-         CALL wrk_dealloc( jpi, jpj, jpk, jptra, ztrdt ) 
       END IF
       !
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/TRP/trcrad.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/TRP/trcrad.F90	(revision 7909)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/TRP/trcrad.F90	(revision 7910)
@@ -139,5 +139,5 @@
       REAL(wp) :: ztrcorb, ztrmasb   ! temporary scalars
       REAL(wp) :: zcoef, ztrcorn, ztrmasn   !    "         "
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::   ztrtrdb, ztrtrdn   ! workspace arrays
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   ztrtrdb, ztrtrdn   ! workspace arrays
       REAL(wp) :: zs2rdt
       LOGICAL ::   lldebug = .FALSE.
@@ -145,5 +145,4 @@
 
  
-      IF( l_trdtrc )  CALL wrk_alloc( jpi, jpj, jpk, ztrtrdb, ztrtrdn )
       
       IF( PRESENT( cpreserv )  ) THEN   !  total tracer concentration is preserved 
@@ -226,5 +225,4 @@
       ENDIF
 
-      IF( l_trdtrc )  CALL wrk_dealloc( jpi, jpj, jpk, ztrtrdb, ztrtrdn )
 
    END SUBROUTINE trc_rad_sms
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/TRP/trcsbc.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/TRP/trcsbc.F90	(revision 7909)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/TRP/trcsbc.F90	(revision 7910)
@@ -65,6 +65,6 @@
       REAL(wp) ::   zswitch, zftra, zcd, zdtra, ztfx, ztra         ! temporary scalars
       CHARACTER (len=22) :: charout
-      REAL(wp), POINTER, DIMENSION(:,:  ) :: zsfx
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: ztrtrd
+      REAL(wp), DIMENSION(jpi,jpj) :: zsfx
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: ztrtrd
 
       !!---------------------------------------------------------------------
@@ -73,6 +73,4 @@
       !
       ! Allocate temporary workspace
-                      CALL wrk_alloc( jpi,jpj,       zsfx   )
-      IF( l_trdtrc )  CALL wrk_alloc( jpi,jpj,jpk,   ztrtrd )
       !
       zrtrn = 1.e-15_wp
@@ -190,6 +188,4 @@
                                            CALL prt_ctl_trc( tab4d=tra, mask=tmask, clinfo=ctrcnm, clinfo2='trd' )
       ENDIF
-                      CALL wrk_dealloc( jpi,jpj,       zsfx   )
-      IF( l_trdtrc )  CALL wrk_dealloc( jpi,jpj,jpk,   ztrtrd )
       !
       IF( nn_timing == 1 )  CALL timing_stop('trc_sbc')
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/TRP/trczdf.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/TRP/trczdf.F90	(revision 7909)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/TRP/trczdf.F90	(revision 7910)
@@ -55,5 +55,5 @@
       INTEGER               ::  jk, jn
       CHARACTER (len=22)    :: charout
-      REAL(wp), POINTER, DIMENSION(:,:,:,:) ::   ztrtrd   ! 4D workspace
+      REAL(wp), DIMENSION(jpi,jpj,jpk,jptra) ::   ztrtrd   ! 4D workspace
       !!---------------------------------------------------------------------
       !
@@ -61,5 +61,4 @@
       !
       IF( l_trdtrc )  THEN
-         CALL wrk_alloc( jpi, jpj, jpk, jptra, ztrtrd )
          ztrtrd(:,:,:,:)  = tra(:,:,:,:)
       ENDIF
@@ -77,5 +76,4 @@
             CALL trd_tra( kt, 'TRC', jn, jptra_zdf, ztrtrd(:,:,:,jn) )
          END DO
-         CALL wrk_dealloc( jpi, jpj, jpk, jptra, ztrtrd )
       ENDIF
       !                                          ! print mean trends (used for debugging)
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/TRP/trdmxl_trc.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/TRP/trdmxl_trc.F90	(revision 7909)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/TRP/trdmxl_trc.F90	(revision 7910)
@@ -34,5 +34,4 @@
    USE prtctl            ! print control
    USE sms_pisces        ! PISCES bio-model
-   USE wrk_nemo          ! Memory allocation
 
    IMPLICIT NONE
@@ -102,8 +101,7 @@
       !
       INTEGER ::   ji, jj, jk, isum
-      REAL(wp), POINTER, DIMENSION(:,:) :: zvlmsk
-      !!----------------------------------------------------------------------
-
-      CALL wrk_alloc( jpi, jpj, zvlmsk )
+      REAL(wp), DIMENSION(jpi,jpj) :: zvlmsk
+      !!----------------------------------------------------------------------
+
 
       ! I. Definition of control surface and integration weights
@@ -188,5 +186,4 @@
       END SELECT
       !
-      CALL wrk_dealloc( jpi, jpj, zvlmsk )
       !
    END SUBROUTINE trd_mxl_trc_zint
@@ -246,14 +243,14 @@
       REAL(wp) ::   zavt, zfn, zfn2
       !
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::   ztmltot             ! d(trc)/dt over the anlysis window (incl. Asselin)
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::   ztmlres             ! residual = dh/dt entrainment term
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::   ztmlatf             ! for storage only
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::   ztmlrad             ! for storage only (for trb<0 corr in trcrad)
-      !
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::   ztmltot2            ! -+
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::   ztmlres2            !  | working arrays to diagnose the trends
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::   ztmltrdm2           !  | associated with the time meaned ML
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::   ztmlatf2            !  | passive tracers
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::   ztmlrad2            !  | (-> for trb<0 corr in trcrad)
+      REAL(wp), DIMENSION(jpi,jpj,jptra) ::   ztmltot             ! d(trc)/dt over the anlysis window (incl. Asselin)
+      REAL(wp), DIMENSION(jpi,jpj,jptra) ::   ztmlres             ! residual = dh/dt entrainment term
+      REAL(wp), DIMENSION(jpi,jpj,jptra) ::   ztmlatf             ! for storage only
+      REAL(wp), DIMENSION(jpi,jpj,jptra) ::   ztmlrad             ! for storage only (for trb<0 corr in trcrad)
+      !
+      REAL(wp), DIMENSION(jpi,jpj,jptra) ::   ztmltot2            ! -+
+      REAL(wp), DIMENSION(jpi,jpj,jptra) ::   ztmlres2            !  | working arrays to diagnose the trends
+      REAL(wp), DIMENSION(jpi,jpj,jptra) ::   ztmltrdm2           !  | associated with the time meaned ML
+      REAL(wp), DIMENSION(jpi,jpj,jptra) ::   ztmlatf2            !  | passive tracers
+      REAL(wp), DIMENSION(jpi,jpj,jptra) ::   ztmlrad2            !  | (-> for trb<0 corr in trcrad)
       !
       CHARACTER (LEN=10) ::   clvar
@@ -261,6 +258,4 @@
 
       ! Set-up pointers into sub-arrays of workspaces
-      CALL wrk_alloc( jpi, jpj, jptra, ztmltot , ztmlres , ztmlatf , ztmlrad             )
-      CALL wrk_alloc( jpi, jpj, jptra, ztmltot2, ztmlres2, ztmlatf2, ztmlrad2, ztmltrdm2 )
 
       IF( nn_dttrc  /= 1  )   CALL ctl_stop( " Be careful, trends diags never validated " )
@@ -742,6 +737,4 @@
       IF( lrst_trc )   CALL trd_mxl_trc_rst_write( kt )  ! this must be after the array swap above (III.3)
 
-      CALL wrk_dealloc( jpi, jpj, jptra, ztmltot , ztmlres , ztmlatf , ztmlrad             )
-      CALL wrk_dealloc( jpi, jpj, jptra, ztmltot2, ztmlres2, ztmlatf2, ztmlrad2, ztmltrdm2 )
       !
    END SUBROUTINE trd_mxl_trc
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/prtctl_trc.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/prtctl_trc.F90	(revision 7909)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/prtctl_trc.F90	(revision 7910)
@@ -68,8 +68,7 @@
       CHARACTER (len=20), ALLOCATABLE, DIMENSION(:) ::   cl
       CHARACTER (len=10) ::   cl2
-      REAL(wp), POINTER, DIMENSION(:,:,:)  :: zmask, ztab3d 
-      !!----------------------------------------------------------------------
-
-      CALL wrk_alloc( jpi, jpj, jpk, zmask, ztab3d )
+      REAL(wp), DIMENSION(jpi,jpj,jpk)  :: zmask, ztab3d 
+      !!----------------------------------------------------------------------
+
       ALLOCATE( cl(jptra) )
       !                                      ! Arrays, scalars initialization 
@@ -148,5 +147,4 @@
       END DO
       !
-      CALL wrk_dealloc( jpi, jpj, jpk, zmask, ztab3d )
       DEALLOCATE( cl )
       !
